Scriptname din_Main extends Quest  Conditional
{functions and properties relating to the main functionality of Devious Interests}

Import StorageUtil

zadlibs Property libs  Auto
zadcLibs Property clibs  Auto

din_Utility Property din_util  Auto
din_Config Property din_cfg  Auto

;===========================================================================================UPDATE SCRIPT START==========================================================================================
;stores if the player's restraints are covered by their clothes or not
Bool Property IsVisiblyBound = False  Auto Hidden Conditional

;stores the time when the last restraint comment happened
Float Property LastRestraintComment = 0.0  Auto Hidden
;stores if the restraint comments are currently on cooldown or not
Bool Property RestraintCommentOnCooldown = False Auto Hidden Conditional

;stores the time when the player last masturbated
Float Property LastMasturbationTime = 0.0  Auto Hidden
;stores if masturbation is currently on cooldown or not
Bool Property MasturbationOnCooldown = False  Auto Hidden

;stores the time when the player last tied herself up
Float Property LastSelfBondageTime = 0.0  Auto Hidden
;stores if self bondage is currently on cooldown or not
Bool Property SelfBondageOnCooldown = False  Auto Hidden

;stores the time when the player last stripped
Float Property LastStrippingTime = 0.0  Auto Hidden
;stores if stripping is currently on cooldown or not
Bool Property StrippingOnCooldown = False  Auto Hidden
;stores if the player needs to be naked or not
Bool Property IsNakedTime = False  Auto Hidden

;stores when the player was last cummed into
Float Property LastCumflationTime = 0.0  Auto Hidden

;stores the time of the last hourly update for events
Float Property LastHourlyUpdate = 0.0  Auto Hidden

;stores the last time free use successfully triggered
Float Property LastFreeUseTime = 0.0  Auto Hidden
;stores if free use is currently on cooldown or not
Bool Property FreeUseOnCooldown = False  Auto Hidden

;stores the last time bondage addiction was checked during an hourly update
;used to account for hourly checks missed during sleeping, waiting for fast traveling
Float Property LastBondageAddictionCheck = 0.0  Auto Hidden

;stores the last time sleep bondage happened
Float Property LastSleepBondage = 0.0  Auto Hidden
;stores if sleep bondage is currently on cooldown or not
Bool Property SleepBondageOnCooldown = False  Auto Hidden

;stores if chastity belts are enabled
Bool Property ChastityBeltEnabled = True  Auto Hidden Conditional

;stores if LBS is installed
Bool Property HasLBS = False  Auto Hidden Conditional

;stores if DMC is installed
Bool Property HasDMC = False  Auto Hidden Conditional

;stores if LVSK is installed
;Bool Property HasLVSK = False  Auto Hidden Conditional
;the main quest of LVSK
;lvskMain Property LoveSickQuest = None  Auto Hidden

;stores if dhlp suspend is in effect
Bool Property DINEventsSuspended = False Auto Hidden Conditional

;stores if the player is currently in jail or not
Bool Property IsPlayerJailed = False  Auto Hidden Conditional

Bool Property FlenSexEventPending = False Auto Hidden

;runs every 30 seconds to evaluate for events and conditions
Function PeriodicUpdate()

	din_util.LogInfo( "Periodic update running" )

	;fire the hourly update every 1 hour
	If ( din_util.GameDaysPassed.GetValue() - LastHourlyUpdate ) * 24.0 > 1.0
		HourlyUpdate()
	EndIf

	;update the cooldown's progress only if the comments are actually on cooldown
	If RestraintCommentOnCooldown
		;if there has been this many hours since the last restraint comment action, the cooldown is over and comments can happen again
		If ( din_util.GameDaysPassed.GetValue() - LastRestraintComment ) * 24.0 > din_cfg.RestraintCommentCooldownTimer
			RestraintCommentOnCooldown = False
			din_util.LogInfo( "Restraint comment cooldown timer is over, restraint comment actions can now happen again" )
		Else
			din_util.LogInfo( "Restraint comment cooldown timer is in effect, restraint comment actions cannot happen" )
		EndIf
	EndIf

	;if events are suspended due to dhlp suspend event, return, do not process any of the subsequent events
	If DINEventsSuspended
		din_util.LogInfo( "Mod functions are suspended due to dhlp-suspend event, returning" )
		Return
	EndIf

	;start a free use attempt
	If ( din_cfg.Global_NonCon.GetValueInt() == 1 ) && ( din_cfg.FreeUseEnabled )
		If FreeUseOnCooldown
			;update the timers for free use
			If ( din_util.GameDaysPassed.GetValue() - LastFreeUseTime ) * 24.0 > din_cfg.FreeUseCooldownTimer
				FreeUseOnCooldown = False
				din_util.LogInfo( "Free use cooldown timer over, free use attempts can now happen again" )
			Else
				din_util.LogInfo( "Free use cooldown timer is in effect, free use attempts cannot happen" )
			EndIf
		;if free use isn't on cooldown, start the feaure
		Else
			;if the free use attempt is successful, return from the function and don't check for further events
			If FreeUseAttempt()
				Return
			EndIf
		EndIf
	EndIf

	;check only if the self bondage feature is active
	If din_cfg.SelfBondageEnabled
		If SelfBondageOnCooldown
			;update the timers for self bondage
			If ( din_util.GameDaysPassed.GetValue() - LastSelfBondageTime ) * 24.0 > din_cfg.SelfBondageCooldownTimer
				SelfBondageOnCooldown = False
				din_util.LogInfo( "Self bondage cooldown timer over, self bondage can now happen again" )
			Else
				din_util.LogInfo( "Self bondage cooldown timer is in effect, self bondage cannot happen" )
			EndIf
		;if self bondage isn't on cooldown, start the feature
		Else
			;if the self bondage attempt is successful, return from the function and don't check for further events
			If SelfBondagePlayer()
				Return
			EndIf
		EndIf		
	EndIf

	;check only if the stripping feature is active
	If din_cfg.StrippingEnabled
		If StrippingOnCooldown
			;update the timers for stripping
			;update cooldown
			If ( din_util.GameDaysPassed.GetValue() - LastStrippingTime ) * 24.0 > din_cfg.StrippingCooldownTimer
				StrippingOnCooldown = False
				din_util.LogInfo( "Stripping cooldown timer over, stripping can now happen again" )
			Else
				din_util.LogInfo( "Stripping cooldown timer is in effect, stripping cannot happen" )
			EndIf
			;update naked time
			If ( din_util.GameDaysPassed.GetValue() - LastStrippingTime ) * 24.0 > din_cfg.NakedTime
				IsNakedTime = False
				din_util.LogInfo( "Naked time is over, the player can now dress up again" )
			Else
				din_util.LogInfo( "Naked time is in effect, the player cannot dress up" )
			EndIf
		;if stripping isn't on cooldown, start the feature
		Else
			StripPlayer()
		EndIf
	Else
		;if the feature is disabled, stop naked time in order to avoid getting stuck naked
		If IsNakedTime
			IsNakedTime = False
			din_util.LogInfo( "Stripping is disabled, cancelling active naked time. Player can dress up again." )
		EndIf
	EndIf

	;check only if the masturbation feature is active
	If din_cfg.MasturbationEnabled
		If MasturbationOnCooldown
			;chastity belt awareness, if the player is belted, cooldown until she wants to masturbate again is halved
			If ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt ) && ( ( din_util.GameDaysPassed.GetValue() - LastMasturbationTime ) * 24.0 > ( din_cfg.MasturbationCooldownTimer / 2.0 ) ) )
				MasturbationOnCooldown = False
				din_util.LogInfo( "Masturbation cooldown time over, masturbation can now happen again" )
			;if masturbation is on cooldown, she won't play with herself, only the timer updates
			ElseIf ( din_util.GameDaysPassed.GetValue() - LastMasturbationTime ) * 24.0 > din_cfg.MasturbationCooldownTimer
				MasturbationOnCooldown = False
				din_util.LogInfo( "Masturbation cooldown timer over, masturbation can now happen again" )
			Else
				din_util.LogInfo( "Masturbation cooldown timer is in effect, masturbation cannot happen" )
			EndIf
		;if masturbation isn't on cooldown, start the feaure
		Else
			MasturbatePlayer() 
		EndIf
	EndIf
EndFunction

;runs every 1 in-game hour to update for certain events and conditions
Function HourlyUpdate()

	din_util.LogInfo( "Hourly update running" )

	LastHourlyUpdate = din_util.GameDaysPassed.GetValue()

	;update the player's arousal by the number of layers of cum on her body
	;affected by the arousal multiplier
	Int CumCount = libs.SexLab.CountCum( libs.PlayerRef )
	
	If CumCount > 0
		libs.Aroused.UpdateActorExposure( libs.PlayerRef, Math.Floor( CumCount * din_cfg.ArousalMultiplier ) )
		Debug.Notification( "Having cum on your body makes you more aroused." )
	EndIf

	;update the player's cum inflation status
	;check only if the cum inflation feature is active
	If din_cfg.Cumflation
		;check only if the player is actually inflated
		If ( GetFloatValue( libs.PlayerRef, "CumflationLevel" ) > 0.0 )
			;check if enough time has passed for coom to start to leak out
			If ( ( LastHourlyUpdate - LastCumflationTime ) * 24.0 > din_cfg.CumflationTimer )
				;cum will only leak out if the player is not plugged
				If libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugVaginal )
					Debug.Notification( "Your plug prevents cum from leaking out of your pussy." )
				Else
					;cum loads will leak 1 per hour
					din_util.Cumflation( -1 )
					libs.Moan( libs.PlayerRef )
					Debug.Notification( "Cum is leaking out of your pussy." )
					libs.SexLab.AddCum( libs.PlayerRef, true, false, false )
				EndIf
			Else
				;update arousal by cum level
				libs.Aroused.UpdateActorExposure( libs.PlayerRef,  Math.Floor( GetFloatValue( libs.PlayerRef, "CumflationLevel" ) ) )
				Debug.Notification( "Having your womb filled with cum makes you more aroused." )
			EndIf
		EndIf
	EndIf
	
	Int RestraintNum = din_util.GetRestraintNum( libs.PlayerRef )

	If RestraintNum > 0
		;update the player's arousal by the number of worn restraints
		;affected by the arousal multiplier
		Int ArousalUpdateValue = Math.Floor( RestraintNum * din_cfg.ArousalMultiplier ) as Int
		libs.Aroused.UpdateActorExposure( libs.PlayerRef, ArousalUpdateValue )
		If ArousalUpdateValue > 0
			Debug.Notification( "Wearing restraints makes you more aroused." )
		ElseIf ArousalUpdateValue < 0
			Debug.Notification( "Wearing restraints makes you less aroused." )
		EndIf
	EndIf

	If din_cfg.BondageAddictionEnabled && ( ( LastHourlyUpdate - LastBondageAddictionCheck ) * 24 >= 1.0 )
		;restraints with a manipulated lock won't count
		If libs.Config.UseItemManipulation && CheckForManipulatedRestraints()
			din_util.LogInfo( "One of the player's restraints has manipulated locks, addiction effects will not be fulfilled." )
		EndIf
		;increase bondage addiction values if:
		;the player is not at full bondage addiction value
		;the last check for bondage addiction was at least over 1hr ago
		;the player wears restraints or is locked in a DD contraption
		If ( GetFloatValue( libs.PlayerRef, "BondageAddictionLevel" ) < 168.0 ) && ( RestraintNum > 0 || clibs.GetDevice( libs.PlayerRef ) )
			;increase the player's bondage addiction by:
			;+1.0 for the base value of wearing at least one restraint
			;+0.25 for any other restraint worn
			Float BondageAddictionIncrease = 1.0 + ( ( RestraintNum - 1 ) * 0.25 )
			;+5.0 for being locked in a contraption
			If clibs.GetDevice( libs.PlayerRef )
				BondageAddictionIncrease += 5.0
			EndIf
			;final adjustment value is multiplied by the number of hours passed since the last check
			BondageAddictionIncrease *= ( ( LastHourlyUpdate - LastBondageAddictionCheck ) * 24.0 )
			AdjustFloatValue( libs.PlayerRef, "BondageAddictionLevel", BondageAddictionIncrease )
			din_util.LogInfo( "Bondage addiction level increased by: " + BondageAddictionIncrease )
			BondageAddiction()
			LastBondageAddictionCheck = LastHourlyUpdate
		ElseIf ( GetFloatValue( libs.PlayerRef, "BondageAddictionLevel" ) > 0.0 ) && ( RestraintNum == 0 && !clibs.GetDevice( libs.PlayerRef ) )
			;bondage addiction will decrease at half of the base increase rate if no restraints are worn (-0.5 with every hour passed)
			AdjustFloatValue( libs.PlayerRef, "BondageAddictionLevel", -0.5 * ( ( LastHourlyUpdate - LastBondageAddictionCheck ) * 24.0 ) )
			din_util.LogInfo( "Bondage addiction level decreased by 0.5" )
			BondageAddiction()
			LastBondageAddictionCheck = LastHourlyUpdate
		EndIf
	EndIf
	
EndFunction

Event OnUpdate()
	PeriodicUpdate()
	RegisterForSingleUpdate( 30.0 )
EndEvent

;============================================================================================UPDATE SCRIPT END===========================================================================================


;=========================================================================================EVENT HANDLER START============================================================================================
;register for events to process
Event OnInit()
	din_util.LogInfo( "Initializing Devious Interests" )
	SetFloatValue( libs.PlayerRef, "CumflationLevel", 0.0 )
	SetFloatValue( libs.PlayerRef, "BondageAddiction", 0.0 )
    LastLootedContainers = new Int[25]
    ;add the perk to the player that allows keys and restraints to be found as loot
    libs.PlayerRef.AddPerk( LootPerk )
    din_cfg.CheckForSoftDependencies()
    RegisterForEvents()
	RegisterForSingleUpdate( 30.0 )
EndEvent

Function RegisterForEvents()
	RegisterForModEvent( "HookOrgasmStart", "OnOrgasmStart" )
	RegisterForModEvent( "HookAnimationEnd", "OnAnimationEnd" ) ; FLEN
	RegisterForModEvent( "dhlp-Suspend", "OnDhlpSuspend" )
	RegisterForModEvent( "dhlp-Resume", "OnDhlpResume" )
	RegisterForSleep()
EndFunction

;orgasm event that handles:
;- cum inflation
;- bondage addiction reprive
Event OnOrgasmStart( Int ThreadID, Bool HasPlayer )
	;only do anything if cum inflation is enabled and the scene involves the player
 	If ( !DINEventsSuspended && din_cfg.Cumflation && HasPlayer )
 		sslThreadController Controller = libs.Sexlab.ThreadSlots.GetController( ThreadID )
 		Actor[] Actors = Controller.Positions
		;1 male procudes 1 unit of coom
		Int Males = libs.SexLab.MaleCount( Actors )
		;1 creature produces 2 units of coom
		Int Creatures = 2 * ( libs.SexLab.CreatureCount( Actors ) )
		;requires at least one male or one creature (always male) to produce coom
		If ( Males >= 1 || Creatures >= 1 )
			;only go further if her pussy was cummed into
			If Controller.Animation.hasTag( "Vaginal" )
				;inflate by the number of guys that fucked her
				Int Partners = Males + Creatures
				din_util.Cumflation( Partners )
				;set when this happened
				LastCumflationTime = din_util.GameDaysPassed.GetValue()
			EndIf
		EndIf
 	EndIf

 	;process only if bondage addiciton is enabled
 	If ( din_cfg.BondageAddictionEnabled && libs.PlayerRef.HasSpell( BondageAddictionLvl3 ) )
 		;masturbation does not count, the player needs to have sex with another actor
 		If libs.Sexlab.ThreadSlots.GetController( ThreadID ).Positions.Length > 1
 			;only add the reprive spell if it isn't already on the player
 			If !libs.PlayerRef.HasSpell( BondageAddicitonReprive )
 				libs.PlayerRef.AddSpell( BondageAddicitonReprive, False )
 			EndIf
 		EndIf
 	EndIf

	din_util.ReleaseEncounter() ; FLEN - release any encounters that
EndEvent

Event OnAnimationEnd( Int ThreadID, Bool HasPlayer ) ; FLEN
	If HasPlayer
		; FLEN - any sex event involving player can blanket finish any encounter started by this mod
		; This is used to delay release of sex events like masturbation
		din_util.ReleaseEncounter() 
	EndIf
EndEvent

;dhlp event handlers
Event OnDhlpSuspend( string eventName, string strArg, float numArg, Form sender )
	DINEventsSuspended = True
	din_util.LogInfo( "dhlp-suspend event received, suspending mod functions" )	
EndEvent

Event OnDhlpResume( string eventName, string strArg, float numArg, Form sender )
	;unsuspend events only if the respective mcm option is not ticked
	If din_cfg.Suspended
		din_util.LogInfo( "dhlp-resume event received, mod is set to suspended state, will not resume mod functions" )
	Else
		DINEventsSuspended = False
		din_util.LogInfo( "dhlp-resume event received, resuming mod functions" )
	EndIf
EndEvent

;sleep event handlers
Event OnSleepStart( Float afSleepStartTime, Float afDesiredSleepEndTime )
	;strip the player if Sleep Naked is active
	If din_cfg.SleepNaked
		libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = False )
	EndIf
	;update the sleep bondage cooldown
	If ( LastHourlyUpdate - LastSleepBondage ) * 24.0 > 6.0
		SleepBondageOnCooldown = False
	EndIf
EndEvent

Event OnSleepStop( Bool abInterrupted )
	;if sleep wasn't interrupted, sleep bondage is enabled and is not on cooldown, make an attempt at it
	If !abInterrupted && !DINEventsSuspended && !IsPlayerJailed && din_cfg.SleepBondageChance > 0.0 && !SleepBondageOnCooldown
		If SleepBondage()
			;if the sleep bondage was successful, set cooldown
			LastSleepBondage = din_util.GameDaysPassed.GetValue()
			SleepBondageOnCooldown = True
		EndIf
	EndIf

	Utility.Wait( 0.1 )

	;roll for a stripping event if the player slept naked
	If din_cfg.StrippingEnabled && !DINEventsSuspended
		If !( libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ClothingBody" ) ) && libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ArmorCuirass" ) ) )
			If Utility.RandomInt( 0, 100 ) < libs.Aroused.GetActorArousal( libs.PlayerRef )
				LastStrippingTime = din_util.GameDaysPassed.GetValue()
				StrippingOnCooldown = True
				IsNakedTime = True
				Debug.Notification( "After sleeping in the nude, you don't want to dress up right now!" )
			EndIf
		EndIf
	EndIf
EndEvent

;=========================================================================================EVENT HANDLER END==============================================================================================


;============================================================================================EVENTS START================================================================================================
;functions and variables used in determining and starting dialogue outcomes

Float Roll_Outcome = 0.0  Conditional

Bool CanBeFucked = True  Conditional

;generate a random number for Roll_Outcome
Function RandomRoll()
	Roll_Outcome = Utility.RandomFloat( 0.0, 100.0 )
EndFunction

;calculate the chances for each possible outcome based on MCM values
;roll a random number to be checked against the calculated outcome chances
Function CalcChances()
	;calculate the chances only if the actions are not currently on cooldown
	If RestraintCommentOnCooldown == False
		;calculate the total chance of outcomes based on MCM values
		RandomRoll()
	EndIf
	;check if the player can be fucked, sex events will only happen if she can be
	Fuckability()
	;check if any of the player's restraints have manipulated locks
	;only makes sense to check it if the respective option is enabled in the DD mcm
	If libs.Config.UseItemManipulation
		CheckForManipulatedRestraints()
	EndIf
EndFunction

;also used to determine and the flag if the player is available to be fucked
Function Fuckability()
	CanBeFucked = din_util.CanBeFucked( libs.PlayerRef )
EndFunction

;sets the cooldown for the restraint comment actions and saves the time of the last action for reference
Function SetRestraintCommentCooldown()

	LastRestraintComment = din_util.GameDaysPassed.GetValue()
	RestraintCommentOnCooldown = True
	
EndFunction

;stores the last 10 people the player talked to, in order to prevent spamming of prostitution and unlock help
FormList Property LastTalkedToPeople  Auto

;used to manage the list that stores the last several actors that the player approached with special requests like restraint help
Function SetLastTalkedTo( Actor Speaker )

	ActorBase SpeakerActorBase = Speaker.GetBaseObject() as ActorBase

	;put the new actor in only if it's not already present in the list
	If !LastTalkedToPeople.HasForm( SpeakerActorBase )
		LastTalkedToPeople.AddForm( SpeakerActorBase )
	EndIf

	;if the list is full, start cycling actors and remove the oldest entry
	If LastTalkedToPeople.GetSize() == 10
		LastTalkedToPeople.RemoveAddedForm( LastTalkedToPeople.GetAt( 0 ) )
	;if somehow this list grew larger than intended, just flush it
	ElseIf LastTalkedToPeople.GetSize() > 10
		LastTalkedToPeople.Revert()
	EndIf
	
EndFunction

;used to start the masturbation feature
Function MasturbatePlayer()
	din_util.LogInfo( "Starting masturbation attempt" )
	;check player arousal to determine if she has a chance to masturbate
	Int PlayerArousal = libs.Aroused.GetActorArousal( libs.PlayerRef )
	;check days since last orgasm to determine how desperate the player is

	If ( PlayerArousal >= din_cfg.Global_ArousalThreshold.GetValueInt() )
		;roll the chance to start masturbating, checked against arousal
		Int Masturbation_Roll = Utility.RandomInt( 0, 100 )

		;the more aroused she is, the more likely it is for her to want to play with her pussy
		;add bonus chances to the roll, the higher the arousal, the bigger the bonus chance, based on percentage of total arousal
		If PlayerArousal >= 75
			;add 15 bonus chance
			Masturbation_Roll -= 15
		ElseIf ( PlayerArousal < 75 && PlayerArousal >= 50 )
			;add 10 bonus chance
			Masturbation_Roll -= 10
		ElseIf ( PlayerArousal < 50 && PlayerArousal >= 25 )
			;add 5 bonus chance
			Masturbation_Roll -= 5
		EndIf

		If din_cfg.UseDaysSinceLastOrgasm
			;the more recently she orgasmed, the less likely it is for her to want to masturbate
			;and vice versa
			FLoat SincePlayerOrgasmed = libs.Aroused.GetActorDaysSinceLastOrgasm( libs.PlayerRef )
			If SincePlayerOrgasmed < 1.0
				;add 25 negative chance
				Masturbation_Roll += 25
			ElseIf ( SincePlayerOrgasmed > 2.0 && SincePlayerOrgasmed < 3.0 )
				;add 5 bonus chance
				Masturbation_Roll -= 5
			ElseIf  SincePlayerOrgasmed >= 3.0
				;add 15 bonus chance
				Masturbation_Roll -= 15
			EndIf
		EndIf

		;check arousal against the roll
		If ( Masturbation_Roll < PlayerArousal )
			;on a successful roll, set cooldown and start masturbation
			;validate the player, so no masturbation will start in scenes, dialogue and in combat, on horseback, in water or until the intro quest is finished
			If ( din_util.ValidateActor( libs.PlayerRef ) && !UI.IsMenuOpen( "Dialogue Menu" ) && !UI.IsMenuOpen( "Crafting Menu" ) && !libs.PlayerRef.IsSwimming() && !libs.PlayerRef.IsOnMount() )

				If din_util.CanClaimEncounter() ; FLEN

					;the player cannot masturbate while her hands are bound, so play a struggle animation instead
					SendModEvent( "dhlp-Suspend" )
					LastMasturbationTime = din_util.GameDaysPassed.GetValue()
					MasturbationOnCooldown = True
					If libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
						Debug.Notification( "Bound as you are, you cannot hope to please yourself!" )
						libs.PlayHornyAnimation( libs.PlayerRef )

						din_util.ReleaseEncounter() ; FLEN

						Return
					EndIf
					;player is valid to masturbate, proceed
					Debug.Notification( "You cannot contain your desire to please yourself anymore!" )
					libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = True )
					libs.Masturbate( libs.PlayerRef, true ) ; FLEN - clain released in "OnAnomationEnd" event
					libs.SexLab.RegisterforModEvent("HookAnimationEnd", "SexlabEventDone")

					SendModEvent( "dhlp-Resume" )

				EndIf
			Else
				;player is invalid to masturbate, try again at the next update, no cooldown
				;only makes sense to trigger the notification only when she's not getting banged
				If ( !libs.IsAnimating( libs.PlayerRef ) )
					Debug.Notification( "You cannot give in to your lust right now, no matter how much you want it!" )
				EndIf
			EndIf
		Else
			;give a warning that the player has avoided giving in to lust
			;only makes sense to trigger the notification only when she's not getting banged
			If ( !libs.IsAnimating( libs.PlayerRef ) && !libs.PlayerRef.WornHasKeyword ( libs.zad_DeviousHeavyBondage ) && Quest.GetQuest( "MQ101" ).IsStageDone( 1000 ) )
				Debug.Notification( "You have managed to resist your desire to play with yourself!" )
				LastMasturbationTime = din_util.GameDaysPassed.GetValue()
				MasturbationOnCooldown = True
			EndIf
		EndIf
	EndIf
EndFunction

;used to start the self bondage feature
Bool Function SelfBondagePlayer()
	din_util.LogInfo( "Starting self bondage attempt" )
	;check player arousal to determine if she has a chance to tie herself up
	Int PlayerArousal = libs.Aroused.GetActorArousal( libs.PlayerRef )
	;check the number of restraints the player is wearing
	Int NumWornRestraints = din_util.GetRestraintNum( libs.PlayerRef )

	If ( PlayerArousal >= din_cfg.Global_ArousalThreshold.GetValueInt() && ( NumWornRestraints < din_cfg.MaxRestraintsNum ) )
		;Debug.Notification( "Player aroused enough for self bondage" )
		;roll the chance to start self bondage, checked against arousal
		Int SelfBondage_Roll = Utility.RandomInt( 0, 100 )

		;the more aroused she is, the more likely it is for her to want to tie herself up
		;add bonus chances to the roll, the higher the arousal, the bigger the bonus chance, based on percentage of total arousal
		If PlayerArousal >= 75
			;add 15 bonus chance
			SelfBondage_Roll -= 15
		ElseIf ( PlayerArousal < 75 && PlayerArousal >= 50 )
			;add 10 bonus chance
			SelfBondage_Roll -= 10
		ElseIf ( PlayerArousal < 50 && PlayerArousal >= 25 )
			;add 5 bonus chance
			SelfBondage_Roll -= 5
		EndIf

		If din_cfg.UseDaysSinceLastOrgasm
			;the more recently she orgasmed, the less likely it is for her to want to tie herself up
			;and vice versa
			FLoat SincePlayerOrgasmed = libs.Aroused.GetActorDaysSinceLastOrgasm( libs.PlayerRef )
			If SincePlayerOrgasmed < 1.0
				;add 25 negative chance
				SelfBondage_Roll += 25
			ElseIf ( SincePlayerOrgasmed > 2.0 && SincePlayerOrgasmed < 3.0 )
				;add 5 bonus chance
				SelfBondage_Roll -= 5
			ElseIf  SincePlayerOrgasmed >= 3.0
				;add 15 bonus chance
				SelfBondage_Roll -= 15
			EndIf
		EndIf

		;roll is checked against arousal and number of worn restraints
		If ( ( SelfBondage_Roll < PlayerArousal ) )
			;Debug.Notification( "Self bondage roll success" )
			;validate the player, so no self bondage will start in scenes, dialogue and in combat, on horseback, in water or until the intro quest is finished
			If ( din_util.ValidateActor( libs.PlayerRef ) && !UI.IsMenuOpen( "Dialogue Menu" ) && !UI.IsMenuOpen( "Crafting Menu" ) && !libs.PlayerRef.IsSwimming() && !libs.PlayerRef.IsOnMount() )

				If !din_util.CanClaimEncounter() ; FLEN
					Debug.Notification( "Your desire to be bound and helpless is driving you mad!" ) ; FLEN
					Return False
				EndIf

				;if there are no DD items in the player's inventory, return instantly
				;determined by if there are more inventory items than rendered items in the inventory of the player
				LastSelfBondageTime = din_util.GameDaysPassed.GetValue()
				SelfBondageOnCooldown = True
				If !( libs.PlayerRef.GetItemCount( libs.zad_InventoryDevice ) > libs.PlayerRef.GetItemCount( libs.zad_Lockable ) )
					Debug.Notification( "Despite your desire to be bound, you don't have any restraints you could wear." )
					libs.PlayHornyAnimation( libs.PlayerRef )

					;if Devious Mimic Clothes is installed, a mimic will attempt to trigger here
					If HasDMC
						din_util.LogInfo( "Self Bondage: sending dmcAttemptMimicTrigger event" )
						Int Handle = ModEvent.Create( "dmcAttemptMimicTrigger" )
						ModEvent.PushForm( Handle,  Self )
						ModEvent.PushForm( Handle, libs.PlayerRef )
						ModEvent.PushForm( Handle, None )
						ModEvent.PushFloat( Handle, -1.0 )
						ModEvent.Send( Handle )
					EndIf

					din_util.ReleaseEncounter() ; FLEN

					Return False
				EndIf
				;the player cannot tie herself up while her hands are bound, so play a struggle animation instead
				If ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage ) )
					Debug.Notification( "Bound as you are, you cannot lock more restraints on yourself!" )
					libs.PlayHornyAnimation( libs.PlayerRef )

					din_util.ReleaseEncounter() ; FLEN

					Return False
				EndIf
				;player is valid for self bondage, proceed
				Debug.Notification( "Your desire to be bound and helpless overwhelms you!" )
				libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = True )
				libs.PlayHornyAnimation( libs.PlayerRef )

				;events after this happen based on if the restraint equip was successful or not
				If din_util.EquipRandomRestraintFromInventory( libs.PlayerRef )
					Debug.Notification( "Giving in to your need for bondage, you lock whatever restraints you can on yourself." )
					;trigger only if the drop keys chance is not 0.0 (disabled) and the player actually has keys to drop from her inventory
					If ( din_cfg.DropKeysChance != 0.0 )
						If din_util.HasKeys( libs.PlayerRef)
							;roll for the chance to drop the player's keys
							RandomRoll()
							;modify the roll outcome with the player's current arousal
							If ( Roll_Outcome - ( PlayerArousal * din_cfg.ArousalMultiplier ) < din_cfg.DropKeysChance )
								Debug.Notification( "Not wanting to be unlocked, you throw away your keys." )
								din_util.DropPlayerKeys()
							EndIf
						EndIf
					EndIf

					din_util.ReleaseEncounter() ; FLEN

					Return True
				Else
					Debug.Notification( "Despite your desire to be bound, you don't have any more restraints you could wear." )

					din_util.ReleaseEncounter() ; FLEN

					Return False
				EndIf
			Else
				;player is invalid for self bondage, try again at the next update, no cooldown
				;only makes sense to trigger the notification only when she's not getting banged
				If ( !libs.IsAnimating( libs.PlayerRef ) )
					Debug.Notification( "You cannot tie yourself up right now, no matter how much you want it!" )
					Return False
				EndIf
			EndIf
		Else
			;give a warning that the player has avoided giving in to lust
			;only makes sense to trigger the notification only when she's not getting banged
			If ( !libs.IsAnimating( libs.PlayerRef ) && !libs.PlayerRef.WornHasKeyword ( libs.zad_DeviousHeavyBondage ) && Quest.GetQuest( "MQ101" ).IsStageDone( 1000 ) )
				Debug.Notification( "You have managed to resist your desire to be bound tight!" )
				LastSelfBondageTime = din_util.GameDaysPassed.GetValue()
				SelfBondageOnCooldown = True
			EndIf
			Return True
		EndIf	
	EndIf
	Return False
EndFunction

;used to start the stripping feature
Function StripPlayer()
	din_util.LogInfo( "Starting stripping attempt" )
	;check player arousal to determine if she has a chance to strip
	Int PlayerArousal = libs.Aroused.GetActorArousal( libs.PlayerRef )

	;check if the player's arousal is high enough, and if she has clothing or armor on
	If ( PlayerArousal >= din_cfg.Global_ArousalThreshold.GetValueInt() && ( libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ClothingBody" ) ) || libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ArmorCuirass" ) ) ) )
		;roll the chance to start stripping, checked against arousal
		Int Stripping_Roll = Utility.RandomInt( 0, 100 )

		;the more aroused she is, the more likely it is for her to want to strip
		;add bonus chances to the roll, the higher the arousal, the bigger the bonus chance, based on percentage of total arousal
		If PlayerArousal >= 75
			;add 15 bonus chance
			Stripping_Roll -= 15
		ElseIf ( PlayerArousal < 75 && PlayerArousal >= 50 )
			;add 10 bonus chance
			Stripping_Roll -= 10
		ElseIf ( PlayerArousal < 50 && PlayerArousal >= 25 )
			;add 5 bonus chance
			Stripping_Roll -= 5
		EndIf

		If din_cfg.UseDaysSinceLastOrgasm
			;the more recently she orgasmed, the less likely it is for her to want to strip
			;and vice versa
			FLoat SincePlayerOrgasmed = libs.Aroused.GetActorDaysSinceLastOrgasm( libs.PlayerRef )
			If SincePlayerOrgasmed < 1.0
				;add 25 negative chance
				Stripping_Roll += 25
			ElseIf ( SincePlayerOrgasmed > 2.0 && SincePlayerOrgasmed < 3.0 )
				;add 5 bonus chance
				Stripping_Roll -= 5
			ElseIf  SincePlayerOrgasmed >= 3.0
				;add 15 bonus chance
				Stripping_Roll -= 15
			EndIf
		EndIf

		;check arousal against the roll
		If ( Stripping_Roll < PlayerArousal )
			;on a successful roll, set cooldown and start stripping
			;validate the player, so no stripping will start in scenes, dialogue and in combat, on horseback, in water or until the intro quest is finished
			If ( din_util.ValidateActor( libs.PlayerRef ) && !UI.IsMenuOpen( "Dialogue Menu" ) && !UI.IsMenuOpen( "Crafting Menu" ) && !libs.PlayerRef.IsSwimming() && !libs.PlayerRef.IsOnMount() )

				If din_util.CanClaimEncounter() ; FLEN

					LastStrippingTime = din_util.GameDaysPassed.GetValue()
					StrippingOnCooldown = True
					;the player cannot strip while her hands are bound
					If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
						;player is valid to strip, proceed
						Debug.Notification( "You cannot contain your desire to get naked anymore!" )
						libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = True )
						IsNakedTime = True
					Else
						Debug.Notification( "Your restraints prevent you from getting naked!" )
					EndIf

					din_util.ReleaseEncounter() ; FLEN
				Else

					Debug.Notification( "You wish you could get naked right now!" )

				EndIf
			Else
				;player is invalid to strip, try again at the next update, no cooldown
				;only makes sense to trigger the notification only when she's not getting banged
				If ( !libs.IsAnimating( libs.PlayerRef ) )
					Debug.Notification( "You cannot get naked right now, no matter how much you want it!" )
				EndIf
			EndIf
		Else
			;give a warning that the player has avoided giving in to lust
			;only makes sense to trigger the notification when she's not getting banged
			If ( !libs.IsAnimating( libs.PlayerRef ) && !libs.PlayerRef.WornHasKeyword ( libs.zad_DeviousHeavyBondage ) && Quest.GetQuest( "MQ101" ).IsStageDone( 1000 ) )
				Debug.Notification( "You have managed to resist your desire to get naked!" )
			EndIf
			LastStrippingTime = din_util.GameDaysPassed.GetValue()
			StrippingOnCooldown = True
		EndIf
	EndIf
EndFunction

;used to start the free use feature
Bool Function FreeUseAttempt()
	din_util.LogInfo( "Starting free use attempt" )
	;if the player can't have sex, return instantly
	If ( !din_util.CanBeFucked( libs.PlayerRef ) )
		;set cooldown and return false so other events can be evaluated
		;LastFreeUseTime = din_util.GameDaysPassed.GetValue()
		;FreeUseOnCooldown = True
		din_util.LogInfo( "The player cannot have sex, aborting free use attempt" )
		Return False
	Else
		;start scanning for sex partners
		din_util.ScannedSexPartners.Revert()
		din_util.FreeUseScanSpell.Cast( libs.PlayerRef )
		Utility.Wait( 2.0 )

		Actor SexPartner = None

		Int i = 0

		If din_util.ScannedSexPartners.GetSize() > 0
			;find a fitting sex partner in the list of scanned potential partners
			While ( SexPartner == None && i < din_util.ScannedSexPartners.GetSize() )
				;select an actor from the list randomly
				Actor Test = din_util.ScannedSexPartners.GetAt( i ) as Actor

				Actor[] TestActors = new Actor[2]
				TestActors[0] = libs.PlayerRef
				TestActors[1] = Test

				;check if they have supported sex animations
				sslBaseAnimation[] SAnims = libs.SelectValidDDAnimations( TestActors, 2 )

				;if there are fitting animations, use this actor for sex
				;introduced additional checks to test the actor is in the same cell as the player and if their 3D model is loaded
				If SAnims.Length > 0 && Test.GetParentCell() == libs.PlayerRef.GetParentCell() && Test.Is3DLoaded()
					SexPartner = Test
					din_util.LogInfo( SexPartner.GetLeveledActorBase().GetName() + " is a valid sex partner" )
				Else
					din_util.LogInfo( SexPartner.GetLeveledActorBase().GetName() + " is not a valid sex partner" )
				EndIf
				i += 1
			EndWhile
		Else
			din_util.LogInfo( "No sex partner is found, aborting free use attempt" )
			;if no sex partners are found, return
			Return False
		EndIf

		;sanity check to make sure we go no further if all potential sex partners are invalid
		If SexPartner == None
			din_util.LogInfo( "No sex partner is found, aborting free use attempt" )
			Return False
		EndIf

		;check player arousal to be added to the success chance
		Int PlayerArousal = libs.Aroused.GetActorArousal( libs.PlayerRef )

		;roll the chance to start a free use attempt, checked against the selected sex partner's arousal
		Int FreeUseRoll = Utility.RandomInt( 0, 100 )

		;the more aroused she is, the more likely it is for her to want to be fucked
		;add bonus chances to the roll, the higher the arousal, the bigger the bonus chance, based on percentage of total arousal
		If PlayerArousal >= 75
			;add 15 bonus chance
			FreeUseRoll -= 15
		ElseIf ( PlayerArousal < 75 && PlayerArousal >= 50 )
			;add 10 bonus chance
			FreeUseRoll -= 10
		ElseIf ( PlayerArousal < 50 && PlayerArousal >= 25 )
			;add 5 bonus chance
			FreeUseRoll -= 5
		EndIf

		;add bonus chance for a naked player
		If !( libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ClothingBody" ) ) && libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ArmorCuirass" ) ) )
			;add 10 bonus chance
			FreeUseRoll -= 10
		EndIf

		;add bonus chance for a visibly restrainted player
		If din_util.CheckVisiblyBound()
			;add 10 bonus chance
			FreeUseRoll -= 10
		EndIf

		;add bonus chance for a cum covered player
		FreeUseRoll -= libs.SexLab.CountCum( libs.PlayerRef )

		;add bonus chance for a player wearing the Sex Slave Collar
		If libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "dinc_SexSlaveCollarDevice" ) )
			FreeUseRoll -= 5
		EndIf

		;check the arousal value against the roll
		If ( FreeUseRoll < libs.Aroused.GetActorArousal( SexPartner ) )
			din_util.LogInfo( "Free use roll successful" )
			;on a successful roll, set cooldown and start a sex scene
			;validate the player, so no sex scene will start in scenes, dialogue and in combat, on horseback, in water or until the intro quest is finished
			If ( din_util.ValidateActor( libs.PlayerRef ) && !UI.IsMenuOpen( "Dialogue Menu" ) && !UI.IsMenuOpen( "Crafting Menu" ) && !libs.PlayerRef.IsSwimming() && !libs.PlayerRef.IsOnMount() )
				
				If !din_util.CanClaimEncounter() ; FLEN
					Return False
				EndIf

				din_util.LogInfo( "Player is valid, starting free use sex" )
				SendModEvent( "dhlp-Suspend" )
				Debug.Notification( "You are going to be used by " + SexPartner.GetLeveledActorBase().GetName() )
				LastFreeUseTime = din_util.GameDaysPassed.GetValue()
				FreeUseOnCooldown = True
				;do the seggs
				din_util.FuckPlayer( SexPartner, false ) ; FLEN - claim released in "OnAnimationEnd" event and possibly in din_Utility hook
				din_util.ScannedSexPartners.Revert()
				SendModEvent( "dhlp-Resume" )

				Return True
			Else
				din_util.LogInfo( "Player is invalid, aborting free use attempt" )
				Return False
			EndIf
		Else
			din_util.LogInfo( "Free use roll unsuccessful" )
			;LastFreeUseTime = din_util.GameDaysPassed.GetValue()
			;FreeUseOnCooldown = True
			Return False
		EndIf
	EndIf	
EndFunction

;used to start a sleep bondage event
Bool Function SleepBondage()
	;check player arousal to be added to the success chances
	Float PlayerArousal = libs.Aroused.GetActorArousal( libs.PlayerRef ) * din_cfg.ArousalMultiplier

	;roll for sleep bondage, if the player is wearing less than the max number of restraints set in the MCM
	If ( din_util.GetRestraintNum( libs.PlayerRef ) < din_cfg.MaxRestraintsNum )

		Float SleepBondageRoll = Utility.RandomFloat( 0.0, 100.0 )

		;the more aroused she is, the more likely it is for her to end up tied
		;add bonus chances to the roll, the higher the arousal, the bigger the bonus chance, based on percentage of total arousal
		If PlayerArousal >= 75.0
			;add 15 bonus chance
			SleepBondageRoll -= 15.0
		ElseIf ( PlayerArousal < 75.0 && PlayerArousal >= 50.0 )
			;add 10 bonus chance
			SleepBondageRoll -= 10.0
		ElseIf ( PlayerArousal < 50.0 && PlayerArousal >= 25.0 )
			;add 5 bonus chance
			SleepBondageRoll -= 5.0
		EndIf

		;add bonus chance for a naked player
		If !( libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ClothingBody" ) ) && libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ArmorCuirass" ) ) )
			;add 10 bonus chance
			SleepBondageRoll -= 10.0
		EndIf

		;add bonus chance for a cum covered player
		SleepBondageRoll -= libs.SexLab.CountCum( libs.PlayerRef )

		If ( SleepBondageRoll < din_cfg.SleepBondageChance && !libs.PlayerRef.GetCurrentLocation().HasKeywordString( "LocTypePlayerHouse" ) )
			din_util.LogInfo( "Sleep bondage roll success" )
			;check how many pieces of restraints can the player still wear
			Int PossibleRestraintNum = din_cfg.MaxRestraintsNum - din_util.GetRestraintNum( libs.PlayerRef )

			;if there is more than 1 slot available, select a random number between 1 and the max possible number of restraints the player can still wear
			If PossibleRestraintNum > 1
				Int i = Utility.RandomInt( 1 , PossibleRestraintNum )
				While i <= PossibleRestraintNum
					RestrainPlayer()
					i += 1
				EndWhile
			Else
				;otherwise, just select a single restraint to equip
				RestrainPlayer()
			EndIf

			;add some coom on the player if noncon is enabled
			If din_cfg.Global_NonCon.GetValueInt() == 1
				libs.SexLab.AddCum( libs.PlayerRef, False, True, False )
			EndIf

			;key theft can happen too
			If din_util.HasKeys( libs.PlayerRef ) && ( Utility.RandomFloat( 0.0, 100.0 ) < din_cfg.KeyTheftChance )
				din_util.DropPlayerKeys()
				Debug.MessageBox( "You wake up and realize that someone has locked you in restraints while you slept! And to make matters worse, they took all of your keys too!" )
			;and gold theft can happen as well
			ElseIf libs.PlayerRef.GetItemCount( din_util.Gold ) >= 100 && ( Utility.RandomFloat( 0.0, 100.0 ) < din_cfg.GoldTheftChance )
				Int StolenGold = ( ( Math.Floor( libs.PlayerRef.GetItemCount( din_util.Gold ) / 100 ) as Int ) * din_cfg.GoldTheftPercentage )
				libs.PlayerRef.RemoveItem( din_util.Gold, StolenGold )
				Debug.MessageBox( "You wake up and realize that someone has locked you in restraints while you slept! And to make matters worse, they took some of your gold too!" )
			Else
				Debug.MessageBox( "You wake up and realize that someone has locked you in restraints while you slept!" )
			EndIf

			Return True
		Else
			din_util.LogInfo( "Sleep bondage roll unsuccessful or player is in safe area" )
			Return False
		EndIf
	Else
		din_util.LogInfo( "The player is already wearing the maximum number of allowed restraints, aborting sleep bondage event" )
		Return False
	EndIf
EndFunction

;bondage addiction spells:
;+10 carry weight
;+5% sneak
Spell Property BondageAddictionLvl1  Auto
;+15 stamina
;+5% stamina regen
;+15 magicka
;+5% magicka regen
;+15 health
;+5% health regen
;+10 speech
Spell Property BondageAddictionLvl2  Auto
;bondage addiction - when not wearing restraints:
;-25% lockpick and pickpocket
;-15 carry weight
;-20 magicka
;-20 stamina
;-25% stamina regen
;-25% magicka regen
;-25% health regen
;-15% weapon damage
Spell Property BondageAddictionLvl3  Auto
;reprive for lvl 3 addiction after sex
Spell Property BondageAddicitonReprive  Auto

;used to adjust the perks and effects associated with the bondage addiction feature
Function BondageAddiction()

	Float BondageAddictionLevel = GetFloatValue( libs.PlayerRef, "BondageAddictionLevel" )

	;used to reset and clear addiction upon deactivating this feature
	If !din_cfg.BondageAddictionEnabled
		SetFloatValue( libs.PlayerRef, "BondageAddiction", 0.0 )
		libs.PlayerRef.DispelSpell( BondageAddictionLvl1 )
		libs.PlayerRef.DispelSpell( BondageAddictionLvl2 )
		libs.PlayerRef.DispelSpell( BondageAddictionLvl3 )
		libs.PlayerRef.DispelSpell( BondageAddicitonReprive )
		libs.Aroused.SetActorExhibitionist( libs.PlayerRef, False )
		Return
	EndIf

	;if bondage addiction is at zero and the player is not wearing any restraints
	If BondageAddictionLevel == 0.0 && !libs.PlayerRef.WornHasKeyword( libs.zad_Lockable )
		;then she has recovered from bondage addiction, she will lose all effects that grant benefits and drawbacks
		libs.PlayerRef.DispelSpell( BondageAddictionLvl1 )
		libs.PlayerRef.DispelSpell( BondageAddictionLvl2 ) 
		libs.PlayerRef.DispelSpell( BondageAddictionLvl3 )
		libs.Aroused.SetActorExhibitionist( libs.PlayerRef, False )
		Debug.MessageBox( "Overcoming your bondage addiction, you are no longer feeling down when not wearing any restraints. All bondage addiction effects are removed." )
		Return
	EndIf

	;apply addiction spells at appropriate addiction progression levels
	If BondageAddictionLevel >= 72.0 && BondageAddictionLevel < 120.0 && !libs.PlayerRef.HasSpell( BondageAddictionLvl1 )
		libs.PlayerRef.AddSpell( BondageAddictionLvl1, False )
		Debug.MessageBox( "After wearing restraints uninterrupted for some time, you have gotten used to their presence and they don't hinder you as much anymore. When wearing at least one piece of restraint, your Carry Weight is increased and you get a small bonus to your Sneak." )
	ElseIf BondageAddictionLevel >= 120.0 && BondageAddictionLevel < 144.0 && !libs.PlayerRef.HasSpell( BondageAddictionLvl2 )
		If !libs.PlayerRef.HasSpell( BondageAddictionLvl1 )
			libs.PlayerRef.AddSpell( BondageAddictionLvl1 )
		EndIf
		libs.PlayerRef.AddSpell( BondageAddictionLvl2, False )
		Debug.MessageBox( "After wearing restraints uninterrupted for an extended time, you began to feel happy, comfortable and confident in being restrained. When wearing at least one piece of restraint, your Health, Magicka and Stamina are increased, regenerate faster and you get a small bonus to your Speechcraft." )
	ElseIf BondageAddictionLevel >= 168.0 && !libs.PlayerRef.HasSpell( BondageAddictionLvl3 )
		If !libs.PlayerRef.HasSpell( BondageAddictionLvl2 )
			libs.PlayerRef.AddSpell( BondageAddictionLvl2, False )
		EndIf
		If !libs.PlayerRef.HasSpell( BondageAddictionLvl3 )
			libs.PlayerRef.AddSpell( BondageAddictionLvl3, False )
		EndIf
		libs.PlayerRef.AddSpell( BondageAddictionLvl3, False )
		libs.Aroused.SetActorExhibitionist( libs.PlayerRef, True )
		Debug.MessageBox( "After wearing restraints uninterrupted for a long time, you have become completely reliant on them and cannot imagine not being restrained anymore. You will suffer several negative status effects, unless you are wearing at least one piece of restraint. Additonally, people seeing you naked will increase your arousal." )
	EndIf

EndFunction

;give the player a random key
Function GiveRandomKey()

	libs.PlayerRef.AddItem( din_util.RandomKey, 1 )

EndFunction

;give the player a random minor item - food, potion, gold, lockpick
Function GiveRandomItem()

	libs.PlayerRef.AddItem( din_util.RandomMinorItem, 1 )

EndFunction

;steal the given percentage of the player's gold
;the stolen gold is added to NPC's inventory, the player can steal it back
Function GoldTheft( Actor Robber )

	Int StolenGold = ( ( Math.Floor( libs.PlayerRef.GetItemCount( din_util.Gold ) / 100 ) as Int ) * din_cfg.GoldTheftPercentage )
	libs.PlayerRef.RemoveItem( din_util.Gold, StolenGold )
	Robber.AddItem( din_util.Gold, StolenGold )

EndFunction

;used to store if there are jammable restraints
Bool CanBeJammed = False  Conditional

;used to check if the player has jammable restraint locks for the items in question
Function CheckForUnJammedRestraints()
	;clear the keyword list
	din_util.AllowedKeywords.Revert()

	Int i = 0

	;find the worn items that can be jammed, add their keywords to the formlist
	While( i < din_util.DDKeywords.GetSize() )

		Keyword kwd = din_util.DDKeywords.GetAt( i ) as Keyword

		If libs.PlayerRef.WornHasKeyword( kwd )
			If !libs.IsLockJammed( libs.PlayerRef, kwd )
				din_util.AllowedKeywords.AddForm( kwd )
			EndIf
		EndIf
		i += 1
	EndWhile

	;set the variable if the list is not empty
	If din_util.AllowedKeywords.GetSize() > 0
		CanBeJammed = True
	Endif
EndFunction

;jam a random restraint with an unjammed lock that the player is wearing
;used during restraint "help"
Function JamRestraint()

	Keyword kwd = din_util.AllowedKeywords.GetAt( Utility.RandomInt( 0, din_util.AllowedKeywords.GetSize() - 1 ) ) as Keyword
	libs.JamLock( libs. PlayerRef, kwd )
	debug.Notification( "The lock of your " + libs.GetDeviceName( libs.GetWornDevice( libs.PlayerRef, kwd ) ) + " has been jammed!" )
		
EndFunction

;steal the player's restraint keys
Function KeyTheft( Actor Robber )

	Int RestrKeyCount = libs.PlayerRef.GetItemCount( libs.restraintsKey )
	Int ChastKeyCount = libs.PlayerRef.GetItemCount( libs.chastityKey )
	Int PiercKeyCount = libs.PlayerRef.GetItemCount( libs.piercingKey )
	Int FurniKeyCount = libs.PlayerRef.GetItemCount( clibs.zadc_FurnitureKey )

	If RestrKeyCount > 0
		libs.PlayerRef.RemoveItem( libs.restraintsKey, RestrKeyCount )
		Robber.AddItem( libs.restraintsKey, RestrKeyCount )
	EndIf

	If ChastKeyCount > 0
		libs.PlayerRef.RemoveItem( libs.chastityKey, ChastKeyCount )
		Robber.AddItem( libs.chastityKey, ChastKeyCount )
	EndIf

	If PiercKeyCount > 0
		libs.PlayerRef.RemoveItem( libs.piercingKey, PiercKeyCount )
		Robber.AddItem( libs.piercingKey, PiercKeyCount )
	EndIf

	If FurniKeyCount > 0
		libs.PlayerRef.RemoveItem( clibs.zadc_FurnitureKey, FurniKeyCount )
		Robber.AddItem( clibs.zadc_FurnitureKey, FurniKeyCount)
	EndIf

	;steal the player's Protector Charms too, if Devious Mimic Clothing is installed
	If HasDMC
		;pluck the charm's form from the DMC plugin
		Armor ProtectorCharm = Game.GetFormFromFile( 0x000173A8, "DeviousMimicClothes.esp" ) as Armor
		;get the number of charms in the player's inventory
		Int CharmCount = libs.PlayerRef.GetItemCount( ProtectorCharm )
	
		If CharmCount > 0
			libs.PlayerRef.RemoveItem( ProtectorCharm, CharmCount )
			Robber.AddItem( ProtectorCharm, CharmCount )
		EndIf
	EndIf

EndFunction

;unlock punishing restraints on the player because I'm a merciful god
Bool Function UnlockRestraint( Actor Helper )

	Bool RestraintRemoved = False

	If Helper.IsGuard() && libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		libs.UnlockDeviceByKeyword( libs.PlayerRef, libs.zad_DeviousHeavyBondage, True )
		RestraintRemoved = True
	;citizens that are not blacksmiths can only unlock armbinders, elbowbinders and straitjackets
	ElseIf !Helper.IsGuard() && ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmbinder ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmbinderElbow ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousStraitJacket ) )
		libs.UnlockDeviceByKeyword( libs.PlayerRef, libs.zad_DeviousHeavyBondage, True )
		RestraintRemoved = True
	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag )
		libs.UnlockDeviceByKeyword( libs.PlayerRef, libs.zad_DeviousGag, True )
		RestraintRemoved = True
	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBlindfold )
		libs.UnlockDeviceByKeyword( libs.PlayerRef, libs.zad_DeviousBlindfold, True )
		RestraintRemoved = True
	Endif
	
	Return RestraintRemoved
	
EndFunction

;lock a random restraint on the player if she still has room for more
;select from the pool of allowed devices, configured in the MCM
Function RestrainPlayer()

	libs.PlayerRef.SetRestrained()
	libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = false )
	
	Armor RestraintToEquip = din_util.GetRandomRestraintToEquip()

	If ( RestraintToEquip != None )
		;if a belt is selected, also equip plugs, if allowed
		If ( libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_DeviousBelt ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugVaginal ) && din_cfg.AllowPlugs && din_cfg.AddPlugWithBelt )
			;equip an anal plug only if the belt is not open-back
				If ( !libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_PermitAnal ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugAnal ) )
					libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousPlugAnal ) )
				EndIf
			libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousPlugVaginal ) )
		EndIf
		libs.LockDevice( libs.PlayerRef, RestraintToEquip, false )
		;if a plug is selected, also equip a chastity belt for good measure, if allowed
		If ( libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_DeviousPlug ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt ) && din_cfg.AllowBelts )
			libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousBelt ), false )
		EndIf
	Else
		din_util.LogWarning( "Failed to find a restraint to equip" )
	EndIf

	libs.PlayerRef.SetRestrained( false )

EndFunction

;add the appropriate gold in bounty to the player in the local hold
Function AddBounty( Actor Witness )

	Witness.GetCrimeFaction().ModCrimeGold( din_cfg.ReportCrimeGold, false )
	Debug.Notification( din_cfg.ReportCrimeGold + " bounty added to " + Witness.GetCrimeFaction().GetName() )

EndFunction

;used to increase the player's exposure by the given value
Function Tease( Int ModExposureValue )

	libs.EdgedSound.Play( libs.PlayerRef )
	libs.PlayHornyAnimation( libs.PlayerRef )
	libs.Aroused.UpdateActorExposure( libs.PlayerRef, ModExposureValue )
	
EndFunction

;used to trigger the player's soul gem plugs
Function VibratePlayerPlugs()
	;code from DD zadEventVibrate.psc
	Int vibStrength = 0
	Int duration = 0

	If libs.ActorHasKeyword( libs.PlayerRef , libs.zad_EffectVibratingRandom )
		vibStrength = Utility.RandomInt( 1,5 )
	ElseIf libs.ActorHasKeyword( libs.PlayerRef , libs.zad_EffectVibratingVeryStrong )
		vibStrength = 5
	ElseIf libs.ActorHasKeyword( libs.PlayerRef , libs.zad_EffectVibratingStrong )
		vibStrength = 4
	ElseIf libs.ActorHasKeyword( libs.PlayerRef , libs.zad_EffectVibrating )
		vibStrength = 3
	ElseIf libs.ActorHasKeyword( libs.PlayerRef , libs.zad_EffectVibratingWeak )
		vibStrength = 2
	ElseIf libs.ActorHasKeyword( libs.PlayerRef , libs.zad_EffectVibratingVeryWeak )
		vibStrength = 1
	Else
		Return
	EndIf

	libs.VibrateEffect( libs.PlayerRef , vibStrength, duration, teaseOnly=libs.shouldEdgeActor( libs.PlayerRef ) )
EndFunction

;used to strip the player as part of a restraint comment outcome
Function Stripped()

	libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = false )
	;if the stripping feature is enabled, also set naked time so the player will have to spend some time naked
	;also put stripping on cooldown
	If din_cfg.StrippingEnabled
		LastStrippingTime = din_util.GameDaysPassed.GetValue()
		StrippingOnCooldown = True
		IsNakedTime = True
	EndIf
	
EndFunction

;used to store if there are manipulated locks on the player's restraints
Bool HasManipulatedLocks = False Conditional

;used to check if the player has manipulated locks
Bool Function CheckForManipulatedRestraints()
	;clear the keyword list
	din_util.AllowedKeywords.Revert()

	Int i = 0

	;find the worn items that could have been manipulated, add their keywords to the formlist
	While( i < din_util.DDKeywords.GetSize() )

		Keyword kwd = din_util.DDKeywords.GetAt( i ) as Keyword

		If libs.PlayerRef.WornHasKeyword( kwd )
			If libs.IsLockManipulated( libs.PlayerRef, kwd )
				din_util.AllowedKeywords.AddForm( kwd )
			EndIf
		EndIf
		i += 1
	EndWhile

	;set the variable if the list is not empty
	If din_util.AllowedKeywords.GetSize() > 0
		HasManipulatedLocks = True
		Return True
	Else
		HasManipulatedLocks = False
		Return False
	Endif
EndFunction

;engage all manipulated restraint locks
Function EngageManipulatedLocks()

	Int i = 0

	While( i < din_util.AllowedKeywords.GetSize() )
		libs.SetLockUnManipulated( libs.PlayerRef, din_util.AllowedKeywords.GetAt( i ) as Keyword )
		i += 1
	EndWhile

	Debug.Notification( "The manipulated locks of your restraints have been engaged!" )
		
EndFunction

;stores successful unlock
Bool Property UnlockSuccessful = False Auto Hidden Conditional

;used for blacksmiths to check if the restraint given as keyword can be unlocked
;quest items cannot be unlocked
;will set the above conditinal variable for dialogue handling, cost is only subtracted from the player in case of a successful unlock
;unlock cost multipliers: 1.0 for basic, 1.5 for regular, 2.0 for advanced
Function BlacksmithUnlock( Keyword RestraintKeyword, String UnlockCostMult )
	;reset the variable
	UnlockSuccessful = False
	;check if it can be unlocked
	If libs.UnlockDeviceByKeyword( libs.PlayerRef, RestraintKeyword, true )
		;set the variable
		UnlockSuccessful = True
		;successful unlock, deduct pay from player
		If UnlockCostMult == "basic"
			libs.PlayerRef.RemoveItem( din_util.Gold, din_cfg.Global_UnlockCost.GetValueInt() )
		ElseIf UnlockCostMult == "regular"
			libs.PlayerRef.RemoveItem( din_util.Gold, din_cfg.Global_UnlockCostReg.GetValueInt() )
		ElseIf UnlockCostMult == "advanced"
			libs.PlayerRef.RemoveItem( din_util.Gold, din_cfg.Global_UnlockCostAdv.GetValueInt() )
		Else
			din_util.LogError( "BlacksmithUnlock(): Invalid multiplier parameter passed to function" )
		EndIf
	Else
		din_util.LogWarning( "BlacksmithUnlock(): Restraint found by restraint keyword is not unlockable" )
	EndIf
EndFunction

;DD gag talk quest, used for enabling gag speak
zadGagQuestScript Property zadGagQuest  Auto

;DD gag talk speech debuff, added on successful gag speak attempt to still hinder the player
Spell Property zadgag_SpeechDebuff  Auto

;items used to help in gag speak
MiscObject Property Charcoal  Auto
MiscObject Property Ink  Auto
MiscObject Property Paper  Auto
MiscObject Property Quill  Auto

;stores if the writing solutions is used
Bool GagSpeakSuccessWritten = False  Conditional

;stores if the player is too horny to communicate normally
Bool TooHornyToSpeak = False  Conditional

;calculate success with random rolls against chances defined in the MCM
Function CalcGagSpeakSuccess()

	;set the variables and return instantly if gag speak success chance is set to 100%
	If din_cfg.GagSpeakSuccessChance == 100.0
		zadGagQuest.canTalk = True
		libs.PlayerRef.AddSpell( zadgag_SpeechDebuff, false )
		Return
	EndIf

	RandomRoll()
	;the more aroused she is, the more likely it is for her to be not understood by others
	;add arousal with the arousal multiplier to the roll
	Roll_Outcome += ( libs.Aroused.GetActorArousal( libs.PlayerRef ) * din_cfg.ArousalMultiplier )

	GagSpeakSuccessWritten = False
	TooHornyToSpeak = False

	;not wearing heavy bondage allows for some benefits to be understood more easily
	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		;if the player's hands are not bound, and she carries something she can write with, the gag speak attempt will automatically succeed
		If ( libs.PlayerRef.GetItemCount( Paper ) >= 1 && ( ( libs.PlayerRef.GetItemCount( Charcoal ) >= 1 ) || ( libs.PlayerRef.GetItemCount( Ink ) >= 1 && libs.PlayerRef.GetItemCount( Quill ) >= 1 ) ) )
			Debug.Notification( "You write your words on a piece of paper." )
			;the paper is lost
			libs.PlayerRef.RemoveItem( Paper , 1 )
			zadGagQuest.canTalk = True
			GagSpeakSuccessWritten = True
			libs.PlayerRef.AddSpell( zadgag_SpeechDebuff, false )
			Return
		;having unbound hands allows her to express herself a bit more clearly anyway
		Else
			Debug.Notification( "You try to gesture with your hands." )
			Roll_Outcome -= 10
		EndIf
	EndIf

	;will only trigger if the roll is over 100 and guaranteed to fail due to high arousal added
	If ( Roll_Outcome > 100 )
		Debug.Notification( "You are too aroused to make anything but horny moans!" )
		TooHornyToSpeak = True
		;player is too horny, but she gets a tiny chance to succeed because I'm merciful
		Roll_Outcome = Utility.RandomFloat( ( din_cfg.GagSpeakSuccessChance - 1.0 ) , 100.0 )
		;check if sex is availabe in case it fast forwards to sex when the tiny chance did not help
		Fuckability()
	EndIf

	;always succeeds if the gag speak success chance is set to 100%
	If ( Roll_Outcome < din_cfg.GagSpeakSuccessChance )
		zadGagQuest.canTalk = True
		libs.PlayerRef.AddSpell( zadgag_SpeechDebuff, false )
	EndIf

EndFunction

;select a punishment for the player for walking away
Function WalkAwayPunishment( Actor Witness )

	SendModEvent( "dhlp-Suspend" )

	Int Roll = Utility.RandomInt( 1 , 3 )

	If Roll == 1 || ( Roll == 3 && din_cfg.Global_NonCon.GetValueInt() == 0 )
		RestrainPlayer()
	ElseIf Roll == 2
		AddBounty( Witness )
	ElseIf ( Roll == 3 && din_cfg.Global_NonCon.GetValueInt() == 1 )
		din_util.FuckPlayer( Partner = Witness, consensual = False )
	EndIf

	SendModEvent( "dhlp-Resume" )
		
EndFunction

;bondage offer choice handler function, options are given as arguments
Function BondageOffer( String Severity, Actor Partner, Bool Punishment )

	SendModEvent( "dhlp-Suspend" )

	libs.PlayerRef.SetRestrained()
	libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = false )
	;take all of the player's keys beforehand
	KeyTheft( Partner )
	Debug.Notification( Partner.GetLeveledActorBase().GetName() + " takes your keys." )

	If Severity == "light"
		din_util.CreateAndEquipRestraintSet( "light" )
		libs.PlayerRef.AddItem( din_util.Gold, ( din_cfg.BondageOfferRewardBase * 0.5 ) as Int )
		libs.PlayerRef.SetRestrained( false )

	ElseIf Severity == "medium"
		din_util.CreateAndEquipRestraintSet( "medium" )
		libs.PlayerRef.AddItem( din_util.Gold, din_cfg.BondageOfferRewardBase )
		libs.PlayerRef.SetRestrained( false )

	ElseIf Severity == "heavy"
		din_util.CreateAndEquipRestraintSet( "heavy" )
		libs.PlayerRef.AddItem( din_util.Gold, ( din_cfg.BondageOfferRewardBase * 1.5 ) as Int )
		libs.PlayerRef.SetRestrained( false )

	ElseIf Severity == "sex"
		din_util.CreateAndEquipRestraintSet( "sex" )
		libs.PlayerRef.AddItem( din_util.Gold, ( din_cfg.BondageOfferRewardBase * 2 ) )
		libs.PlayerRef.SetRestrained( false )
		din_util.FuckPlayer( Partner )

	ElseIf Severity == "random"
		;select a random severity
		String[] RandomSeverity = new String[4]
		RandomSeverity[0] = "light"
		RandomSeverity[1] = "medium"
		RandomSeverity[2] = "heavy"
		RandomSeverity[3] = "sex"

		String SelectedSeverity = None

		;include sex only if non-con is enabled
		If din_cfg.Global_NonCon.GetValueInt() == 1
			SelectedSeverity = RandomSeverity[Utility.RandomInt( 0, 3 )]
			din_util.CreateAndEquipRestraintSet( SelectedSeverity )
			libs.PlayerRef.SetRestrained( false )
		Else
			SelectedSeverity = RandomSeverity[Utility.RandomInt( 0, 2 )]
			din_util.CreateAndEquipRestraintSet( RandomSeverity[Utility.RandomInt( 0, 2 )] )
			libs.PlayerRef.SetRestrained( false )
		EndIf

		;rewards are only given if this is not a punishment
		If SelectedSeverity == "light" && !Punishment
			libs.PlayerRef.AddItem( din_util.Gold, ( din_cfg.BondageOfferRewardBase * 0.5 ) as Int )
		ElseIf SelectedSeverity == "medium" && !Punishment
			libs.PlayerRef.AddItem( din_util.Gold, din_cfg.BondageOfferRewardBase )
		ElseIf SelectedSeverity == "heavy" && !Punishment
			libs.PlayerRef.AddItem( din_util.Gold, ( din_cfg.BondageOfferRewardBase * 1.5 ) as Int )
		ElseIf SelectedSeverity == "sex"
			If Punishment
				din_util.FuckPlayer( Partner = Partner, consensual = false )
			Else
				libs.PlayerRef.AddItem( din_util.Gold, ( din_cfg.BondageOfferRewardBase * 2 ) )
				din_util.FuckPlayer( Partner )
			EndIf	
		EndIf

	EndIf

	SetRestraintCommentCooldown()

	SendModEvent( "dhlp-Resume" )
	
EndFunction

;equip items used for crime punishment
Function CrimePunishmentRestraints( Actor Guard )

	libs.PlayerRef.SetRestrained()

	libs.SexLab.StripActor( libs.PlayerRef, doanimate = false )

	;taking the restraints reduces the current bounty of the player
	Int crimeGoldViolent = Guard.GetCrimeFaction().GetCrimeGoldViolent()
	Int crimeGoldNonviolent = Guard.GetCrimeFaction().GetCrimeGoldNonviolent()
	
	;if the player's bounty is under the petty crime threshold, only light bondage is applied
	If Guard.GetCrimeFaction().GetCrimeGold() <= din_util.PettyCrimeThreshold.GetValueInt()
		libs.LockDevice( libs.PlayerRef, din_util.GetRandomRestraintToEquip(), True )
		Guard.GetCrimeFaction().ModCrimeGold( -crimeGoldNonviolent, abViolent = False )
		Guard.GetCrimeFaction().ModCrimeGold( -crimeGoldViolent, abViolent = True )
	Else
	;otherwise she is punished with heavy bondage
		If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
			libs.LockDevice( libs.PlayerRef, din_util.GetRandomArmbinding(), True )
		EndIf

		If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag )
			libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousGag ), True )
		EndIf

		If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBlindfold )
			libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousBlindfold ), True )
		EndIf
		
		libs.LockDevice( libs.PlayerRef, din_util.GetRandomRestraintToEquip(), True )
		Guard.GetCrimeFaction().ModCrimeGold(-( Math.Floor(crimeGoldNonviolent / 3) as Int ), abViolent = False )
		Guard.GetCrimeFaction().ModCrimeGold(-( Math.Floor(crimeGoldViolent / 3) as Int ), abViolent = True )
	EndIf

	libs.PlayerRef.SetRestrained( false )

EndFunction

Perk Property LootPerk  Auto
;stores the last 25 containers that the player looted, to see if DD loot can be added to it
Int[] Property LastLootedContainers  Auto Hidden
;used to count the added elements to the container array
Int ContainerCounter = 0

;implements the functionality of the perk adding the key or restraint to the looted container
Function Loot( ObjectReference LootedContainer )

	Int ContainerFormID = LootedContainer.GetFormID()

	;if the currently looted container is in the list, nothing will happen
	If LastLootedContainers.Find( akElement = ContainerFormID, aiStartIndex = 0 ) < 0
		;container ID not found in array, process it, otherwise return
		;if 25 elements are already stored, overwrite the first one
		If ContainerCounter > 24
			ContainerCounter = 0
			LastLootedContainers[ContainerCounter] = ContainerFormID
		Else
		;otherwise put it in the next slot
			LastLootedContainers[ContainerCounter] = ContainerFormID
		EndIf
		ContainerCounter += 1

		If Utility.RandomFloat( 0.0, 100.0 ) < din_cfg.RestraintsLootChance
			;if the player is aroused enough, she has a chance to automatically pick up the restraint
			If din_cfg.CantDropRestraints && ( libs.Aroused.GetActorArousal( libs.PlayerRef ) >= din_cfg.ArousalThreshold ) && ( Utility.RandomInt( 0, 100 ) < libs.Aroused.GetActorArousal( libs.PlayerRef ) )
				libs.PlayerRef.AddItem( din_util.EveryRestraint, 1 )
				Debug.MessageBox( "You have found a restraint while rummaging through the contents of the " + LootedContainer.GetBaseObject().GetName() + ". As you examined it, you couldn't resist its lure and decided to take it with you." )
			Else
				LootedContainer.AddItem( din_util.EveryRestraint, 1, true )
			EndIf
		EndIf

		;process only if key drops are enabled
		If din_cfg.KeysLootChance > 0.0

			Float RandomRoll = Utility.RandomFloat( 0.0, 100.0 )
			
			;dungeon key drop bias calculation, if enabled
			If din_cfg.DungeonKeyBias != 0.0
				If libs.PlayerRef.GetCurrentLocation().HasKeywordString( "LocTypeDungeon" )
					If din_cfg.DungeonKeyBias == -1.0
						din_util.LogInfo( "Dungeon Key Drop Bias is set to minimum value, key drops in dungeons are disabled, returning" )
						Return
					Else
						RandomRoll -= ( 1 * din_cfg.KeysLootChance * din_cfg.DungeonKeyBias )
					EndIf
				Else
					If din_cfg.DungeonKeyBias == 1.0
						din_util.LogInfo( "Dungeon Key Drop Bias is set to maximum value, keys will only drop in dungeons, returning" )
						Return
					Else
						RandomRoll -= ( -1 * din_cfg.KeysLootChance * din_cfg.DungeonKeyBias )
					EndIf
				EndIf
			EndIf
	
			If RandomRoll < din_cfg.KeysLootChance
				If ( ( din_cfg.BoundKeys == 0 ) || ( din_cfg.BoundKeys == 1 && libs.PlayerRef.WornHasKeyword( libs.zad_Lockable ) ) || ( din_cfg.BoundKeys == 2 && !libs.PlayerRef.WornHasKeyword( libs.zad_Lockable ) ) )
					LootedContainer.AddItem( din_util.RandomKey, 1, true )
				EndIf
			EndIf
		EndIf
	EndIf
EndFunction

;implements functionality to allow pickpocketing keys off NPCs
Function Pickpocket( ObjectReference ActorToBeRobbed )

	Int ContainerFormID = ActorToBeRobbed.GetFormID()

	;if the currently checked actor is in the list, nothing will happen
	If LastLootedContainers.Find( akElement = ContainerFormID, aiStartIndex = 0 ) < 0
		If ContainerCounter > 24
			ContainerCounter = 0
			LastLootedContainers[ContainerCounter] = ContainerFormID
		Else
		;otherwise put it in the next slot
			LastLootedContainers[ContainerCounter] = ContainerFormID
		EndIf
		ContainerCounter += 1

		If Utility.RandomFloat( 0.0, 100.0 ) < din_cfg.KeysLootChance
			If ( ( din_cfg.BoundKeys == 0 ) || ( din_cfg.BoundKeys == 1 && libs.PlayerRef.WornHasKeyword( libs.zad_Lockable ) ) || ( din_cfg.BoundKeys == 2 && !libs.PlayerRef.WornHasKeyword( libs.zad_Lockable ) ) )
				ActorToBeRobbed.AddItem( din_util.RandomKey, 1, true )
			EndIf
		EndIf
	EndIf	
EndFunction

;===============================================================================================EVENTS END===============================================================================================


;==========================================================================================RESTRAINT HELP START==========================================================================================
;store the restraint last removed during the restraint help dialogue, in case it needs to get locked back on the player
Armor RemovedRestraint = None

;function to unequip punishing restraints from the player, by order of severity
Function HelpRemoveRestraint( Actor Helper )
	;guards can unlock all heavy restraints
	If Helper.IsGuard() && libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousHeavyBondage )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousHeavyBondage, true, true )

	;citizens that are not blacksmiths can only unlock armbinders, elbowbinders and straitjackets
	ElseIf !Helper.IsGuard() && ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmbinder ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmbinderElbow ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousStraitJacket ) )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousHeavyBondage )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousHeavyBondage, true, true )

	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousGag )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousGag, true, true )

	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBlindfold )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousBlindfold )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousBlindfold, true, true )
	Endif
	
EndFunction

;unequip restraints from the player by using a key, any guard or citizen can unlock any restraint with a key
Function HelpRemoveRestraintWithKey()
	;guards can unlock all heavy restraints
	If libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousHeavyBondage )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousHeavyBondage, true, true )

	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousGag )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousGag, true, true )

	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBlindfold )
		RemovedRestraint = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousBlindfold )
		libs.UnlockDevice( libs.PlayerRef, RemovedRestraint, libs.GetRenderedDevice( RemovedRestraint ), libs.zad_DeviousBlindfold, true, true )
	Endif

	libs.PlayerRef.RemoveItem( libs.restraintsKey, 1 )
	
EndFunction

;locks the player back into the restraint that has just been removed from her because she's been naughty
Function HelpLockBackRestraint()

	libs.PlayerRef.SetRestrained()
	libs.LockDevice( libs.PlayerRef, RemovedRestraint, true)
	RemovedRestraint = None
	libs.PlayerRef.SetRestrained( false )

EndFunction

;pay the npc for unlock services rendered
Function HelpPay( Actor Helper )

	Int UnlockCost = din_cfg.Global_UnlockCost.GetValueInt()

	libs.PlayerRef.RemoveItem( din_util.Gold, UnlockCost )
	Helper.AddItem( din_util.Gold, UnlockCost )

EndFunction

;===========================================================================================RESTRAINT HELP END===========================================================================================


;===========================================================================================PROSTITUTION START===========================================================================================
;store the client for further interaction
ReferenceAlias Property ProstitutionClient  Auto

;store the sex type for calculations
String TypeOfSex

;if NPCs don't like the player prostituting herself, they'll put her in a chastity belt - chance configured in the MCM
Function BeltWhore()

	libs.PlayerRef.SetRestrained()

	Armor BeltToEquip = din_util.GetRestraintToEquip( libs.zad_DeviousBelt )

	libs.SexLab.StripActor( libs.PlayerRef, doanimate = false )

	;add plugs to the chastity belt too, if allowed
	If ( BeltToEquip != None )
		If ( !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlug ) && din_cfg.AllowPlugs )
			If !libs.GetRenderedDevice( BeltToEquip ).HasKeyword( libs.zad_PermitAnal )
				libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousPlugAnal ) )
			EndIf
			libs.LockDevice( libs.PlayerRef, din_util.GetRestraintToEquip( libs.zad_DeviousPlugVaginal ) )
		EndIf
	libs.LockDevice( libs.PlayerRef, BeltToEquip )
	Else
		din_util.LogWarning( "Failed to find a chastity belt to equip" )
	EndIf

	libs.PlayerRef.SetRestrained( false )
	
EndFunction

;calculate the chance for the prostitution attempt to succeed
Function CalcWhoreSuccess( String SexType )
	;roll a random number as a base
	RandomRoll()

	;being naked (not wearing clothing) adds bonus success chance
	If ( !( libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ClothingBody" ) ) ) )
		Roll_Outcome -= 10.0
	EndIf
	
	;wearing heavy bondage adds a large bonus success chance
	If ( SexType == "bound" || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage ) )
		TypeOfSex = "bound"
		Roll_Outcome -= 10.0
	;wearing any restraint adds bonus success chance
	ElseIf libs.PlayerRef.WornHasKeyword( libs.zad_Lockable )
		Roll_Outcome -= ( din_util.GetRestraintNum( libs.PlayerRef ) as Float )
	ElseIf SexType == "oral"
		TypeOfSex = SexType
	;anal adds a medium bonus success chance
	ElseIf SexType == "anal"
		TypeOfSex = SexType
		Roll_Outcome -= 5.0
	ElseIf SexType == "vaginal"
		TypeOfSex = SexType
	EndIf
EndFunction

;calculate the total chance for the player to receieve a reward for whoring
Function CalcWhoreRewardChance()
	;roll a random number as a base
	RandomRoll()

	;the more restraints the player wears, the less likey it is for her to get payed
	If libs.PlayerRef.WornHasKeyword( libs.zad_Lockable )
		Roll_Outcome += ( din_util.GetRestraintNum( libs.PlayerRef ) as Float )
	EndIf
	
EndFunction

;give reward to the player for whoring herself out, reward passed in argument
Function RewardWhore( String Reward )
	;if the DIN content pack is installed and the player is wearing a Sex Slave Collar, no reward if gold is selected
	If din_cfg.IsDINCInstalled && libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "dinc_SexSlaveCollarDevice" ) ) && ( Reward == "gold" )
		ProstitutionClient.Clear()
		;bad girl!
		Debug.Notification( "The Sex Slave Collar punishes you for not offering yourself for free!" )
		Int Handle = ModEvent.Create( "dinc_SexSlaveCollarPunishment" )
		ModEvent.PushString( Handle, "violation" )
		ModEvent.Send( Handle )
		Return
	EndIf

	If ( ( Reward == "gold" ) && ( TypeOfSex == "bound" ) )
		libs.PlayerRef.AddItem( din_util.Gold, 2 * din_cfg.ProstitutionRewardGold )
	ElseIf ( Reward == "gold" )
		libs.PlayerRef.AddItem( din_util.Gold, din_cfg.ProstitutionRewardGold )
	ElseIf ( Reward == "key" )
	 	 GiveRandomKey()
	EndIf

	;clear the alias for future use
	ProstitutionClient.Clear()	
	
EndFunction

;sex function used during prostitution
Function FuckWhore( Actor Customer )

	din_util.CanClaimEncounter() ; FLEN - try to reserve this time if possible so that no other encounter can occur
	SendModEvent( "dhlp-Suspend" )

	;starting tags, to be expanded based on tags in parameters and partner sex
	String SuppressTags = ""
	String IncludeTags = ""

	;if oral only is selected, add it to the keywords to use for selecting a sex animation
	If TypeOfSex == "oral"
		IncludeTags += "Oral"
		SuppressTags += ",Vaginal,Anal"
	ElseIf TypeOfSex == "anal"
		IncludeTags += "Anal"
		SuppressTags += ",Vaginal,Cunnilingus,Titfuck,Boobjob,Footjob,Oral,Blowjob"
	ElseIf TypeOfSex == "vaginal"
		IncludeTags += "Vaginal"
		SuppressTags += ",Anal,Cunnilingus,Titfuck,Boobjob,Footjob,Oral,Blowjob"
	EndIf
	
	;lock the player if bondage sex is chosen
	If TypeOfSex == "bound" && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		libs.LockDevice( libs.PlayerRef, din_util.GetRandomArmbinding() )
	EndIf

	Utility.Wait( 0.5 )

	If din_util.FuckPlayer( Customer, true, IncludeTags, SuppressTags )
		;sex scene was successful, add customer referenceto alias
		ProstitutionClient.ForceRefTo( Customer )
		din_util.LogInfo( "Prostitution sex scene successful" )
	Else
		din_util.LogWarning( "Prostitution sex scene unsuccessful, attempt aborted" )
	EndIf		

	SendModEvent( "dhlp-Resume" )
	din_util.ReleaseEncounter() ; FLEN
	
EndFunction

;============================================================================================PROSTITUTION END============================================================================================